VERSION 5.00
Begin VB.UserControl ctlProgress 
   CanGetFocus     =   0   'False
   ClientHeight    =   1590
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5835
   ScaleHeight     =   106
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   389
   ToolboxBitmap   =   "qProgress.ctx":0000
End
Attribute VB_Name = "ctlProgress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Requires ..: -
'  Additional : -
'  Has help ..: No
'  Has readme : No
'  Has sample : No
'  Created ...: 2003/02/19 (yyyy/mm/dd)
'  Last update: 2009/02/19 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private Const ICC_PROGRESS_CLASS = &H20
Private Const WS_VISIBLE = &H10000000
Private Const WS_CHILD = &H40000000
Private Const PBM_SETRANGE = &H401
Private Const PBM_SETPOS = &H402
Private Const PBM_SETBARCOLOR = &H409
Private Const PBM_SETBKCOLOR = &H2001
Private Const PBM_SETSTEP = &H404
Private Const PBM_STEPIT = &H405
Private Const PBM_SETRANGE32 = &H406
Private Const PBS_SMOOTH = &H1
Private Const PBS_VERTICAL = &H4

Private Type tagINITCOMMONCONTROLSEX
  dwSize As Long
  dwICC As Long
End Type
Private Type PPBRANGE
  iLow As Integer
  iHigh As Integer
End Type

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (lpInitCtrls As tagINITCOMMONCONTROLSEX) As Boolean
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, wParam As Any, lParam As Any) As Long

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal Length As Long)


Public Enum qeDirection
  qDirectionHorizontal = 0
  qDirectionVertical = 1
End Enum

Private hProgress As Long
Private xOldStyleComCtl As Boolean

Private xDirection As qeDirection
Private xSmooth As Boolean
Private xMin As Long
Private xMax As Long
Private xValue As Long
Private Const xIncrement As Long = 1
Private xBarColor As OLE_COLOR
Private xBackColor As OLE_COLOR

Public Property Get BarColor() As OLE_COLOR
  BarColor = xBarColor
End Property

Public Property Let BarColor(BarColor As OLE_COLOR)
  xBarColor = BarColor
  
  SendMessage hProgress, PBM_SETBARCOLOR, ByVal 0, ByVal pGetColor(xBarColor)
  
  PropertyChanged "BarColor"
End Property

Public Property Get BackColor() As OLE_COLOR
  BackColor = xBackColor
End Property

Public Property Let BackColor(BackColor As OLE_COLOR)
  xBackColor = BackColor
  
  SendMessage hProgress, PBM_SETBKCOLOR, ByVal 0, ByVal pGetColor(xBackColor)
  
  PropertyChanged "BackColor"
End Property

Public Property Get Direction() As qeDirection
  Direction = xDirection
End Property

Public Property Let Direction(Direction As qeDirection)
  xDirection = Direction
  pCreateWindow
  PropertyChanged "Direction"
End Property

Public Property Get Smooth() As Boolean
  Smooth = xSmooth
End Property

Public Property Let Smooth(Smooth As Boolean)
  xSmooth = Smooth
  pCreateWindow
  PropertyChanged "Smooth"
End Property

Public Property Get Max() As Long
  Max = xMax
End Property

Public Property Let Max(Max As Long)
  If Max < xMin Then Exit Property

  xMax = Max
  If xMax < xValue Then Value = xMax

  pSetRange

  PropertyChanged "Max"
End Property

Public Property Get Min() As Long
  Min = xMin
End Property

Public Property Let Min(Min As Long)
  If Min > xMax Then Exit Property
  
  xMin = Min
  If xMin > xValue Then Value = xMin

  pSetRange
  
  PropertyChanged "Min"
End Property

Public Property Get Value() As Long
  Value = xValue
End Property

Public Property Let Value(Value As Long)
  If (Value < Min) Or (Value > Max) Then Exit Property

  xValue = Value

  SendMessage hProgress, PBM_SETPOS, ByVal xValue, ByVal 0

  PropertyChanged "Value"
End Property

Public Sub ValueNext()
  If xValue + xIncrement > xMax Then Exit Sub
  xValue = xValue + 1
  SendMessage hProgress, PBM_STEPIT, ByVal 0, ByVal 0
End Sub

Private Sub UserControl_Initialize()
  pInitComCtl
End Sub

Private Sub UserControl_Terminate()
  pDestroyWindow
End Sub

Private Sub UserControl_Paint()
  Value = xValue
End Sub

Private Sub UserControl_Resize()
  pCreateWindow
  If hProgress <> 0 Then
    MoveWindow hProgress, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth - UserControl.ScaleLeft, UserControl.ScaleHeight - UserControl.ScaleTop, 1
  Else
  End If
End Sub

Private Sub UserControl_InitProperties()
  Min = 0
  Max = 100
  Smooth = True
  Direction = qDirectionHorizontal
  Value = 0
  BackColor = vb3DFace
  BarColor = vbHighlight
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Min = PropBag.ReadProperty("Min", 0)
  Max = PropBag.ReadProperty("Max", 100)
  Smooth = PropBag.ReadProperty("Smooth", True)
  Direction = PropBag.ReadProperty("Direction", qDirectionHorizontal)
  Value = PropBag.ReadProperty("Value", 0)
  BackColor = PropBag.ReadProperty("BackColor", vb3DFace)
  BarColor = PropBag.ReadProperty("BarColor", vbHighlight)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "Min", xMin, 0
  PropBag.WriteProperty "Max", xMax, 100
  PropBag.WriteProperty "Smooth", xSmooth, True
  PropBag.WriteProperty "Direction", xDirection, qDirectionHorizontal
  PropBag.WriteProperty "Value", xValue, 0
  PropBag.WriteProperty "BackColor", xBackColor, vb3DFace
  PropBag.WriteProperty "BarColor", xBarColor, vbHighlight
End Sub


Private Sub pCreateWindow()
  If hProgress <> 0 Then pDestroyWindow

  hProgress = CreateWindowEx(0, "msctls_progress32", vbNullString, WS_CHILD Or WS_VISIBLE Or IIf(xSmooth = True, PBS_SMOOTH, 0) Or IIf(xDirection = qDirectionVertical, PBS_VERTICAL, 0), UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth - UserControl.ScaleLeft, UserControl.ScaleHeight - UserControl.ScaleTop, UserControl.hwnd, 0, App.hInstance, ByVal 0)
  SendMessage hProgress, PBM_SETSTEP, ByVal xIncrement, ByVal 0
  SendMessage hProgress, PBM_SETBKCOLOR, ByVal 0, ByVal pGetColor(xBackColor)
  SendMessage hProgress, PBM_SETBARCOLOR, ByVal 0, ByVal pGetColor(xBarColor)
End Sub

Private Sub pDestroyWindow()
  If hProgress = 0 Then Exit Sub

  DestroyWindow hProgress

  hProgress = 0
End Sub


Private Sub pInitComCtl()
  On Error Resume Next
  Dim tmpICC As tagINITCOMMONCONTROLSEX
  tmpICC.dwSize = Len(tmpICC)
  tmpICC.dwICC = ICC_PROGRESS_CLASS
  InitCommonControlsEx tmpICC
  If Err.Number <> 0 Then
    InitCommonControls
    xOldStyleComCtl = True
  Else
    xOldStyleComCtl = False
  End If
End Sub

Private Sub pSetRange()
  pCreateWindow
'  Dim tmpMinMaxB(0 To 3) As Byte, tmpMinMax As Long
'  RtlMoveMemory tmpMinMaxB(2), Min, 2
'  RtlMoveMemory tmpMinMaxB(0), Max, 2
'  RtlMoveMemory tmpMinMax, tmpMinMaxB(0), 4
'  SendMessage hProgress, PBM_SETRANGE, byval 0, ByVal tmpMinMax
  SendMessage hProgress, PBM_SETRANGE32, ByVal xMin, ByVal xMax
End Sub

Private Function pGetColor(Color As OLE_COLOR) As Long
  If (Color And &H80000000) = &H80000000 Then
    pGetColor = GetSysColor(Color Xor &H80000000)
  Else
    pGetColor = Color
  End If
End Function
