VERSION 5.00
Begin VB.UserControl ctlTrayIcon 
   ClientHeight    =   1800
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3195
   ClipBehavior    =   0  'None
   InvisibleAtRuntime=   -1  'True
   LockControls    =   -1  'True
   ScaleHeight     =   120
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   213
   ToolboxBitmap   =   "qTrayIcon.ctx":0000
   Begin VB.PictureBox PictureIcon 
      BorderStyle     =   0  'None
      Height          =   240
      Left            =   930
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   0
      Top             =   240
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Image ImageIcon 
      Height          =   480
      Left            =   45
      Stretch         =   -1  'True
      Top             =   30
      Width           =   480
   End
End
Attribute VB_Name = "ctlTrayIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Author
'  Name .....: Josip Medved
'  E-mail ...: jmedved@vip.hr
'  URL ......: http://web.vip.hr/jmedved.vip/qeyes/

'Information
'  Additional : -
'  Requires ..: -
'  Has help ..: No
'  Has readme : No
'  Has sample : Yes
'  Created ...: - (yyyy/mm/dd)
'  Last update: 2002/04/07 (yyyy/mm/dd)
'  Notes .....: -

'If you use this file in your program it would be nice to mention
'where you got it from, but you are not obligated to do so.


Option Explicit

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type APPBARDATA
  lStructureSize As Long
  hwnd As Long
  lCallBackMessage As Long
  lEdge As Long
  rc As RECT
  lParam As Long
End Type

Private Type NOTIFYICONDATA
  cbSize As Long
  hwnd As Long
  uID As Long
  uFlags As Long
  uCallbackMessage As Long
  hIcon As Long
  szTip As String * 64
End Type

Private TrayIcon As NOTIFYICONDATA

Private Declare Function SHAppBarMessage Lib "Shell32" (ByVal dwMessage&, pData As APPBARDATA) As Long
Private Declare Function Shell_NotifyIcon Lib "Shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long


Private xInTray As Boolean

Private xIcon As StdPicture
Private xToolTipText As String

Public Event DblClick(Button As Integer)
Attribute DblClick.VB_MemberFlags = "200"
Public Event MouseDown(Button As Integer)
Public Event MouseOver()
Public Event MouseUp(Button As Integer)

Public Property Get TaskbarAvailable() As Boolean
  Dim TaskBar As APPBARDATA
  TaskBar.lStructureSize = 36&
  
  If SHAppBarMessage(&H5&, TaskBar) <> 1 Then
    TaskbarAvailable = False
  Else
    TaskbarAvailable = True
  End If
End Property

Public Property Get InTray() As Boolean
  InTray = xInTray
End Property

Public Property Get Icon() As StdPicture
  Set Icon = xIcon
End Property

Public Property Set Icon(Icon As StdPicture)
  Set xIcon = Icon
  ImageIcon.Picture = Icon
  PictureIcon.Picture = ImageIcon.Picture
  PropertyChanged "Icon"
  If xInTray = True Then Show
End Property

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_MemberFlags = "200"
  ToolTipText = xToolTipText
End Property

Public Property Let ToolTipText(yToolTipText As String)
  xToolTipText = Left$(yToolTipText, 63)
  PropertyChanged "ToolTipText"
  If xInTray = True Then Show
End Property

Public Sub Show()
  If TaskbarAvailable = False Then Exit Sub
  TrayIcon.cbSize = Len(TrayIcon)
  TrayIcon.hwnd = PictureIcon.hwnd
  TrayIcon.uID = UserControl.hwnd
  TrayIcon.uFlags = &H7
  TrayIcon.uCallbackMessage = &H200
  TrayIcon.hIcon = PictureIcon.Picture
  TrayIcon.szTip = Left$(xToolTipText, 63) + Chr$(0)
  
  Dim tmpR As Long
  If xInTray = True Then
    tmpR = Shell_NotifyIcon(&H1, TrayIcon)
  Else
    tmpR = Shell_NotifyIcon(&H0, TrayIcon)
    xInTray = True
  End If
End Sub

Public Sub Hide()
  If TaskbarAvailable = False Then Exit Sub
  Dim tmpR As Long
  tmpR = Shell_NotifyIcon(&H2, TrayIcon)
  xInTray = False
End Sub

Private Sub PictureIcon_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Select Case X
    Case 512 'MouseOver
      RaiseEvent MouseOver
    Case 513 'Left Down
      RaiseEvent MouseDown(1)
    Case 514 'Left Up
      RaiseEvent MouseUp(1)
    Case 515 'Left DblClick
      RaiseEvent DblClick(1)
    Case 516 'Right Down
      RaiseEvent MouseDown(2)
    Case 517 'Right Up
      RaiseEvent MouseUp(2)
    Case 518 'Right DblClick
      RaiseEvent DblClick(2)
    Case 519 'MiddleDown
      RaiseEvent MouseDown(3)
    Case 520 'MiddleUp
      RaiseEvent MouseUp(3)
    Case 521 'MiddleDblClick
      RaiseEvent DblClick(3)
  End Select
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  ToolTipText = PropBag.ReadProperty("ToolTipText", "")
  Set Icon = PropBag.ReadProperty("Icon", Nothing)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "ToolTipText", ToolTipText, ""
  PropBag.WriteProperty "Icon", Icon, Nothing
End Sub

Private Sub UserControl_Terminate()
  If xInTray = True Then Hide
End Sub

Private Sub UserControl_Paint()
  UserControl.Line (35, 0)-(35, 36), vbButtonShadow
  UserControl.Line (0, 35)-(36, 35), vb3DShadow
  UserControl.Line (0, 0)-(36, 0), vb3DHighlight
  UserControl.Line (0, 0)-(0, 36), vb3DHighlight
End Sub

Private Sub UserControl_Resize()
  UserControl.Width = 36 * Screen.TwipsPerPixelX
  UserControl.Height = 36 * Screen.TwipsPerPixelY
End Sub
